class GTK_TARGET_ENTRY

inherit

	GTK_DND_EXTERNALS
	
creation

	make

feature

	make(n: STRING; f: INTEGER) is
		require
			name_set: n /= Void and then not n.is_empty
			flag_set: f >= 0 and f <= Gtk_target_same_widget
		do
			name := clone(n)
			set_next_target
			id := next_target
			flags := f
			ptr := c_gtk_target_entry(name.to_external, flags, id)
		ensure
			pointer_set: ptr /= Void
			name_was_set: name.is_equal(n)
			flag_was_set: flags = f
			id_was_set: id > 0
		end

	name: STRING

	flags: INTEGER

	id: INTEGER

	ptr: POINTER

	next_target: INTEGER is
		do
			Result := (gte_array @ 0)
		end

	set_next_target is
		do
			gte_array.put((gte_array @ 0) + 1, 0)
		end

feature {NONE}

	gte_array: ARRAY[INTEGER] is
		once
			create Result.make (0,0)
			Result.put(0,0)
		end

	c_gtk_target_entry(name_ptr: POINTER; f, i: INTEGER): POINTER is
		external
			"C"
		end 

end -- GTK_TARGET_ENTRY
